var utils = {
    getVideoHtmlForText: function (text, cb, webUrl) {
        var that = this;
        var urlReg = /(http|ftp|https):\/\/[\w\-_]+(\.[\w\-_]+)+([\w\-\.,@?^=%&:/~\+#]*[\w\-\@?^=%&/~\+#])?/g;

        // 微博
        // https://weibo.com/tv/v/IzaEvtn7o?fid=1034:4483814916030478
        // https://m.weibo.cn/status/IzaEvtn7o?fid=1034%3A4483814916030478&jumpfrom=weibocom
        // https://weibo.com/1892653244/IzkxgA1iz?type=comment
        // https://m.weibo.cn/status/IzkxgA1iz?type=comment&jumpfrom=weibocom
        // https://video.h5.weibo.cn/1034:4500614890323998/4500617672263779
        var webUrlInfo = that.parseUrl(webUrl);
        if (webUrlInfo.host.indexOf("weibo.com") !== -1 || webUrlInfo.host.indexOf("weibo.cn") !== -1) {
            // 微博
            var videoUrls = [];
            var video720Url = [];
            var matchRes = text.match(urlReg);
            if (matchRes && matchRes.length > 0) {
                console.log("全部网址", matchRes)
                for (var j = 0; j < matchRes.length; j++) {
                    var url = matchRes[j];
                    if (url.indexOf(".mp4") > 0) {
                        // 是视频
                        var isSinaVideo = url.indexOf("video.weibocdn.com") > 0;
                        var is720Video = isSinaVideo && url.indexOf("x720") > 0;
                        var targetArray = is720Video ? video720Url : videoUrls;
                        targetArray.splice(isSinaVideo ? 0 : targetArray.length, 0, url);
                    } else {

                    }
                }
            }
            videoUrls = video720Url.concat(videoUrls);
            // console.log("找到视频地址", videoUrls, parent, player)
            if (videoUrls.length > 0) {
                // 找封面
                var thumb = "https://img.ithome.com/app/images/transparent.png";
                if (text.indexOf("\"page_pic\"") > 0) {
                    var fragment = text.substring(text.indexOf("\"page_pic\""));
                    if (fragment.indexOf("}") > 0) {

                        fragment = fragment.substring(0, fragment.indexOf("}"));
                        var picRes = fragment.match(urlReg);
                        if (picRes && picRes.length == 1) {
                            thumb = picRes[0];
                        }
                    }
                }
                // var Vobject = document.createElement('VIDEO');
                // Vobject.setAttribute("controls", "controls");
                // Vobject.setAttribute("preload", "metadata");
                // Vobject.setAttribute("src", videoUrls[0]);
                // Vobject.setAttribute("poster", thumb);
                // parent.insertBefore(Vobject, document.getElementById(id));
                // player.style.display = 'none';
                var weiboHtml = '<a class="ithome_super_player" target="_blank" href="' + webUrl + '">'
                    + '<video controls  src="' + videoUrls[0] + '" poster="' + thumb + '">您的设备不支持播放视频</video>'
                    + '</a>'
                cb({ plat: "weibo", html: weiboHtml })
            } else {
                cb({ plat: "", html: null })
            }
        } else if (webUrlInfo.host.indexOf(".iqiyi.com") !== -1) {
            // 爱奇艺
            var iqiyiHtml = '<iframe src="https://open.iqiyi.com/developer/player_js/coopPlayerIndex.html?vid={vid}&tvId={tvid}'
                + '&accessToken=2.f22860a2479ad60d8da7697274de9346&appKey=3955c3425820435e86d0f4cdfe56f5e7'
                + '&appId=1368&height=100%&width=100%" frameborder="0" allowfullscreen="true"></iframe>';
            var tvidReg = /data-player-tvid="(\d+)"/;
            var matchTvidResult = text.match(tvidReg);
            var vidReg = /data-player-videoid="([a-f0-9A-F]+)"/;
            var matchVidResult = text.match(vidReg);
            console.log("获取到爱奇艺视频ID", matchTvidResult, matchVidResult);
            if (matchTvidResult && matchTvidResult.length == 2 && matchVidResult && matchVidResult.length == 2) {
                var tvid = matchTvidResult[1];
                var vid = matchVidResult[1];
                cb({ plat: "aiqiyi", html: iqiyiHtml.replace("{vid}", vid).replace("{tvid}", tvid) })
            } else {
                cb({ plat: "", html: null })
            }
        } else {
            var resultList = [];
            var matchRes = text.match(urlReg);
            if (matchRes && matchRes.length > 0) {
                console.log("全部网址", matchRes)
                for (var j = 0; j < matchRes.length; j++) {
                    var url = matchRes[j];
                    var pureUrl = url;
                    var urlInfo = this.parseUrl(url);
                    -1 !== pureUrl.indexOf("?") && (pureUrl = pureUrl.substring(0, pureUrl.indexOf("?")));
                    -1 !== pureUrl.indexOf("#") && (pureUrl = pureUrl.substring(0, pureUrl.indexOf("#")));

                    // B站
                    var avHtml = '<iframe src="https://player.bilibili.com/player.html?aid={avid}&page=1" scrolling="no" '
                        + 'border="0" frameborder="no" framespacing="0" width="100%" allowfullscreen="true"> </iframe>';
                    var bvHtml = '<iframe src="https://player.bilibili.com/player.html?bvid={bvid}&page=1" scrolling="no" '
                        + 'border="0" frameborder="no" framespacing="0" width="100%" allowfullscreen="true"> </iframe>';
                    var bilibiliAvReg = /bilibili.com.+av(\d+)/;
                    var matchResult = pureUrl.match(bilibiliAvReg);
                    var bilibiliBvReg = /bilibili.com.+BV(.+)/;
                    var matchBvResult = pureUrl.match(bilibiliBvReg);
                    if (matchResult && matchResult.length == 2) {
                        var avNum = matchResult[1];
                        if(avNum.indexOf("/") === avNum.length - 1){
                            avNum = avNum.substring(0, avNum.indexOf("/"))
                        }
                        console.log("获取到av号", avNum)
                        resultList.push({ plat: "bilili", html: avHtml.replace("{avid}", avNum) })
                    } else if (matchBvResult && matchBvResult.length == 2) {
                        var bvNum = matchBvResult[1];
                        if(bvNum.indexOf("/") === bvNum.length - 1){
                            bvNum = bvNum.substring(0, bvNum.indexOf("/"))
                        }
                        console.log("获取到BV号", bvNum)
                        resultList.push({ plat: "bilili", html: bvHtml.replace("{bvid}", bvNum) })
                    }

                    // 优酷
                    var youkuHtml = "<iframe src='https://player.youku.com/embed/{youkuId}==' frameborder=0 'allowfullscreen'></iframe>";
                    var youkuIdReg = /youku.com.+id_(.+)==/;
                    var matchYoukuResult = pureUrl.match(youkuIdReg);
                    if (matchYoukuResult && matchYoukuResult.length == 2) {
                        var youkuId = matchYoukuResult[1];
                        console.log("获取到优酷视频ID", youkuId)
                        resultList.push({ plat: "youku", html: youkuHtml.replace("{youkuId}", youkuId) })
                    }

                    // 腾讯视频
                    var tengxunHtml = '<iframe frameborder="0" src="https://v.qq.com/iframe/player.html?vid={tengxunId}&tiny=0&auto=0" allowfullscreen></iframe>';
                    if (urlInfo.host.indexOf("v.qq.com") !== -1) {
                        if (!!urlInfo.params.vid) {
                            console.log("获取到腾讯视频ID1", urlInfo.params.vid)
                            resultList.push({ plat: "tengxun", html: tengxunHtml.replace("{tengxunId}", urlInfo.params.vid) })
                        } else {
                            var tengxunIdReg = /v.qq.com\/x\/page\/(.+)+\.html/;
                            var matchTxResult = pureUrl.match(tengxunIdReg);
                            if(matchTxResult && matchTxResult.length == 2){
                                console.log("获取到腾讯视频ID2", matchTxResult[1])
                                resultList.push({ plat: "tengxun", html: tengxunHtml.replace("{tengxunId}", matchTxResult[1]) })
                            }
                        }
                    }

                    // 网易云音乐
                    if (urlInfo.host === "music.163.com") {
                        var songId = 0;
                        var songReg = /\/song\/(\d+)/;
                        var matchSongResult = pureUrl.match(songReg);
                        if (urlInfo.hash && urlInfo.params.id) {
                            songId = urlInfo.params.id;
                        } else if (matchSongResult && matchSongResult.length === 2) {
                            songId = matchSongResult[1];
                        }
                        if (parseInt(songId) > 0) {
                            resultList.push({
                                plat: "yunyinyue", html: '<iframe frameborder="no" border="0" marginwidth="0" marginheight="0"  '
                                    + ' src="https://music.163.com/outchain/player?type=2&id=' + urlInfo.params.id + '&auto=1&height=66"></iframe>'
                            })
                        }
                    }

                    // 秒拍
                    // https://gslb.miaopai.com/stream/LTELa1rjQUQpPeu-qITUTIrWjaqK8Ay56RYbXA__.mp4
                    // https://www.miaopai.com/show/LTELa1rjQUQpPeu-qITUTIrWjaqK8Ay56RYbXA__.htm
                    var miaopaiHtml = '<iframe src="https://v.miaopai.com/iframe?scid={miaopaiId}" width="720" height="405" allowfullscreen="true" frameborder="0"></iframe>';
                    var miaopaiReg1 = /gslb.miaopai.com\/stream\/(.+).mp4/;
                    var miaopaiReg2 = /miaopai.com\/show\/(.+).htm/;
                    var matchResult1 = pureUrl.match(miaopaiReg1);
                    var matchResult2 = pureUrl.match(miaopaiReg2);
                    if (matchResult1 && matchResult1.length == 2) {
                        var miaoPaiId = matchResult1[1];
                        console.log("获取到秒拍视频ID", miaoPaiId)
                        resultList.push({ plat: "miaopai", html: miaopaiHtml.replace("{miaopaiId}", miaoPaiId) })
                    } else if (matchResult2 && matchResult2.length == 2) {
                        var miaoPaiId = matchResult2[1];
                        console.log("获取到秒拍视频ID", miaoPaiId)
                        resultList.push({ plat: "bilili", html: miaopaiHtml.replace("{miaopaiId}", miaoPaiId) })
                    }

                    // 各自站点的iframe链接，直接支持
                    if (urlInfo.host.toLowerCase() === "player.bilibili.com"
                        || urlInfo.host.toLowerCase() === "player.youku.com"
                        || (urlInfo.host.toLowerCase() === "v.qq.com" && url.indexOf("iframe/player.html") !== -1)
                        || (urlInfo.host.toLowerCase() === "open.iqiyi.com" && url.indexOf("developer/player_js") !== -1)
                        || (urlInfo.host.toLowerCase() === "v.miaopai.com" && url.indexOf("/iframe?scid") !== -1)) {
                        resultList.push({ plat: "player", html: '<iframe frameborder="0" src="' + url.replace("http://", "https://") + '" allowfullscreen="true"></iframe>' })
                    }
                }

                if (resultList.length === 0 && !webUrl) {
                    var urlRequest = matchRes[0].replace("m.iqiyi.com", "www.iqiyi.com");
                    var requestData = {
                        method: "GET",
                        url: urlRequest
                    }
                    var isJsonP = false;
                    // 秒拍页面需要请求接口
                    if (that.parseUrl(urlRequest).host === "n.miaopai.com" && urlRequest.indexOf("/media/") !== -1) {
                        var originalId = urlRequest.substring(urlRequest.indexOf("/media/") + 7);
                        if (originalId.indexOf("?") !== -1) originalId = originalId.substring(0, originalId.indexOf("?"));
                        if (originalId.indexOf("#") !== -1) originalId = originalId.substring(0, originalId.indexOf("#"));
                        if (originalId.indexOf(".htm") !== -1) originalId = originalId.substring(0, originalId.indexOf(".htm"));
                        requestData.url = "https://n.miaopai.com/api/aj_media/info.json?smid=" + originalId + "&appid=530&_cb=_jsonpkz06bk38pe";
                        requestData.header = {
                            Referer: urlRequest
                        }
                        isJsonP = true;
                    }
                    console.log("抓取页面地址", requestData)
                    rm.request(
                        requestData,
                        function (res) {
                            if (res.data) {
                                if (isJsonP) {
                                    res.data = res.data.replace(/\\/g, "");
                                }
                                console.log("获取到HTML", res.data)
                                that.getVideoHtmlForText(res.data, cb, urlRequest);
                            } else {
                                cb({ plat: "", html: null })
                            }
                        }
                    )
                } else {
                    cb(resultList.length > 0 ? resultList[0] : { plat: "", html: null })
                }
            } else {
                cb({ plat: "", html: null })
            }
        }
    },

    parseWeiboVideo: function () {
        var that = this;
        var players = document.getElementsByClassName("ithome_super_player");
        if (players && players.length > 0) {
            for (var i = 0; i < players.length; i++) {
                var player = players[i];
                grabWeiBoVideoUrl(player);
            }
        }
        function grabWeiBoVideoUrl(player) {
            if (typeof window.__videoId == typeof undefined) {
                window.__videoId = 0;
            }
            var urlReg = /(http|ftp|https):\/\/[\w\-_]+(\.[\w\-_]+)+([\w\-\.,@?^=%&:/~\+#]*[\w\-\@?^=%&/~\+#])?/g;
            var parent = player.parentNode;
            var weburl = player.getAttribute("href");
            // console.log(player)
            if (!that.isEmpty(weburl)) {
                rm.request({ url: weburl }, function (res) {
                    if (res.statusCode == 200) {
                        var html = res.data;
                        // console.log("网页", html)
                        var videoUrls = [];
                        var video720Url = [];
                        if (!that.isEmpty(html)) {
                            var matchRes = html.match(urlReg);
                            if (matchRes && matchRes.length > 0) {
                                // console.log("全部网址", matchRes)
                                for (var j = 0; j < matchRes.length; j++) {
                                    var url = matchRes[j];
                                    if (url.indexOf(".mp4") > 0) {
                                        // 是视频
                                        var isSinaVideo = url.indexOf("video.weibocdn.com") > 0;
                                        var is720Video = isSinaVideo && url.indexOf("x720") > 0;
                                        var targetArray = is720Video ? video720Url : videoUrls;
                                        targetArray.splice(isSinaVideo ? 0 : targetArray.length, 0, url);
                                    } else {

                                    }
                                }
                            }
                        }
                        videoUrls = video720Url.concat(videoUrls);
                        // console.log("找到视频地址", videoUrls, parent, player)
                        if (videoUrls.length > 0) {
                            // 找封面
                            var thumb = "https://img.ithome.com/app/images/transparent.png";
                            if (html.indexOf("\"page_pic\"") > 0) {
                                var fragment = html.substring(html.indexOf("\"page_pic\""));
                                if (fragment.indexOf("}") > 0) {

                                    fragment = fragment.substring(0, fragment.indexOf("}"));
                                    var picRes = fragment.match(urlReg);
                                    if (picRes && picRes.length == 1) {
                                        thumb = picRes[0];
                                    }
                                }
                            }
                            // var Vobject = document.createElement('VIDEO');
                            // Vobject.setAttribute("controls", "controls");
                            // Vobject.setAttribute("preload", "metadata");
                            // Vobject.setAttribute("src", videoUrls[0]);
                            // Vobject.setAttribute("poster", thumb);
                            // parent.insertBefore(Vobject, document.getElementById(id));
                            // player.style.display = 'none';
                            var weiboHtml = '<video controls  src="' + videoUrls[0] + '" poster="' + thumb + '">您的设备不支持播放视频</video>';
                            player.innerHTML = weiboHtml;
                        } else if (html.indexOf("没有权限")) {

                        }
                    }
                })
            }
        }
    },


    /**
     * 获取链接信息
     * {
     *  linkType:0,//-2: 错误；-1：普通链接；0、新闻；1、帖子；2、用户;3、专题
     *  normalHtml: '',//普通链接html
        ardHtml :"",//卡片html
    * }
    */
    getLinkHtml: function (src, title, callback) {
        var that = this;
        var linkType = -1;
        var cardId = 0;
        var cardIdStr = "";
        var normalHtml = '';
        var cardHtml = "";
        var linkText = "";
        if (this.isEmpty(src)) {
            linkType = -2;
            sendResult()
            return;
        } else if (!this.isEmpty(title)) {
            linkText = title;
            normalHtml = '<a href="' + src + '" target="_blank">' + title + '</a>';
        } else {
            linkText = src;
            normalHtml = '<a href="' + src + '" target="_blank">' + src + '</a>';
        }
        if (src.indexOf("http://www.ithome.com/html/") == 0 || src.indexOf("http://wap.ithome.com/html/") == 0 ||
            src.indexOf("https://www.ithome.com/html/") == 0 || src.indexOf("https://wap.ithome.com/html/") == 0 ||
            src.indexOf("http://m.ithome.com/html/") == 0 || src.indexOf("https://m.ithome.com/html/") == 0 ||
            src.indexOf("http://live.ithome.com/item/") == 0 || src.indexOf("https://live.ithome.com/item/") == 0) {
            //IT之家新闻(旧)、直播
            var end = src.indexOf(".htm", 20);
            var start = src.lastIndexOf("/", end);
            var newsid = src.substring(start + 1, end);
            linkType = 0;
            cardId = that.encrypt(newsid);
        } else if (src.indexOf("http://www.ithome.com/zt/") == 0 || src.indexOf("https://www.ithome.com/zt/") == 0) {
            //专题页面
            var id = src.substring(src.indexOf('ithome.com/zt/') + 14);
            if (id.indexOf('?') > 0) {
                id = id.substring(0, id.indexOf('?'));
            }
            if (id.indexOf('#') > 0) {
                id = id.substring(0, id.indexOf('#'));
            }
            if (id.indexOf('/') > 0) {
                id = id.substring(0, id.indexOf('/'));
            }
            linkType = 3;
            if (isNumber(id)) {
                cardId = that.encrypt(id);
            } else {
                cardIdStr = id;
            }
        } else if (src.indexOf("https://www.ithome.com/") == 0 ||
            src.indexOf("http://www.ithome.com/") == 0) {
            // IT之家新闻（新）
            // https://www.ithome.com/0/385/509.htm
            if (src.indexOf(".htm") == src.length - 4) {
                var end = src.indexOf(".htm", 6);
                var id = src.substring(end - 10, end).replace(/\//g, "");
                if (that.isNumber(id)) {
                    linkType = 0;
                    cardId = that.encrypt(parseInt(id));
                }
            }

        } else if (src.indexOf("http://quan.ithome.com/user/") == 0 || src.indexOf("https://quan.ithome.com/user/") == 0) {
            //用户页面
            if (src.endsWith('/')) {
                src = src.substring(0, src.length - 1);
            }
            var userId = src.substring(src.lastIndexOf("/") + 1);
            linkType = 2;
            cardId = that.encrypt(userId);
        } else if (src.indexOf("http://quan.ithome.com/") == 0 || src.indexOf("http://quan.ithome.com/wap/") == 0 ||
            src.indexOf("https://quan.ithome.com/") == 0 || src.indexOf("https://quan.ithome.com/wap/") == 0) {
            //帖子详情
            var end = src.indexOf(".htm", 6);
            var id = src.substring(end - 10, end).replace(/\//g, "");
            if (that.isNumber(id)) {
                linkType = 1;
                cardId = that.encrypt(id);
            }
        } else if (src.indexOf("ithome://") == 0) {
            //解析ithome协议链接
            var urlObject = parasUrl(src);

            switch (urlObject.host) {
                case "newstopic": //专题
                    linkType = 3;
                    if (that.isNumber(urlObject.params.id)) {
                        cardId = that.encrypt(urlObject.params.id);
                    } else {
                        cardIdStr = urlObject.params.id;
                    }
                    break
                case "news": //新闻
                    if (urlObject.params.id > 0) {
                        linkType = 0;
                        cardId = that.encrypt(urlObject.params.id);
                    }
                    break
                case "quan": //帖子
                    if (urlObject.params.id > 0) {
                        linkType = 1;
                        cardId = that.encrypt(urlObject.params.id);
                    }
                    break
                case "userpage": //用户资料卡
                    if (urlObject.params.id > 0) {
                        linkType = 2;
                        cardId = that.encrypt(urlObject.params.id);
                    }
                    break
            }
        }

        if (linkType != -1) {
            var api = "https://dyn.ithome.com/api/tool/getcard"; //.replace("{id}", cardId).replace("{type}", linkType);
            api += "?type=" + linkType;
            if (!this.isEmpty(cardIdStr)) {
                api += "&strParm=" + cardIdStr;
            } else if (!this.isEmpty(cardId)) {
                api += "&strId=" + cardId;
            }

            rm.request({ url: api },
                function (res) {
                    if (res.statusCode === 200 && res.data.Ok == 1) {
                        cardHtml = res.data.Content
                    } else {
                        linkType = -1;
                    }
                    sendResult()
                });
        } else {
            sendResult()
        }

        function sendResult() {
            callback({
                linkType: linkType,
                normalHtml: normalHtml,
                cardHtml: cardHtml,
                title: linkText,
                src: src
            });
        }
    },

    encrypt: function (str) {
        return rm.encryptSync({ text: str + "" }).data;
    },

    isNumber: function (value) {
        if (typeof (value) === 'object' || this.isEmpty(value)) {
            return false;
        } else {
            return !Number.isNaN(Number(value));
        }
    },

    isEmpty: function (str) {
        return typeof str == typeof undefined || str == null || str.length == 0;
    },

    parseUrl: function (url) {
        if (!url) {
            return {
                scheme: "",
                host: "",
                params: {},
                hash: ""
            };
        }
        var parts = url.split("://");
        var scheme = parts[1] ? parts[0] : "";
        var domain = parts[1] || parts[0];
        if (domain.indexOf("/") != -1) {
            domain = domain.split("/")[0];
        }
        if (domain.indexOf("?") !== -1) {
            domain = domain.substring(0, domain.indexOf("?"))
        }
        if (domain.indexOf("#") !== -1) {
            domain = domain.substring(0, domain.indexOf("#"))
        }
        var params = {};
        var key = "",
            value = "";
        var paraString = url.substring(url.indexOf("?") + 1, url.length).split("&");
        for (var i in paraString) {
            var str = paraString[i];
            if (str.indexOf("=") > 0) {
                key = str.substring(0, str.indexOf("="));
                value = str.substring(str.indexOf("=") + 1);
                if (value.indexOf("#") !== -1) {
                    value = value.substring(0, value.indexOf("#"));
                }
                params[key] = decodeURIComponent(value);
            }
        }
        return {
            scheme: scheme.toLowerCase(),
            host: domain.toLowerCase(),
            params: params,
            hash: url.indexOf("#") !== -1 ? url.substring(url.indexOf("#") + 1) : ""
        };
    }
}